"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.warnIfCustomerDataLimitReached = exports.CUSTOMER_DATA_BYTES_LIMIT = void 0;
var display_1 = require("./display");
var utils_1 = require("./utils");
// RUM and logs batch bytes limit is 16KB
// ensure that we leave room for other event attributes and maintain a decent amount of event per batch
// (3KB (customer data) + 1KB (other attributes)) * 4 (events per batch) = 16KB
exports.CUSTOMER_DATA_BYTES_LIMIT = 3 * utils_1.ONE_KIBI_BYTE;
function warnIfCustomerDataLimitReached(bytesCount, customerDataType) {
    if (bytesCount > exports.CUSTOMER_DATA_BYTES_LIMIT) {
        display_1.display.warn("The ".concat(customerDataType, " data is over ").concat(exports.CUSTOMER_DATA_BYTES_LIMIT / utils_1.ONE_KIBI_BYTE, "KiB. On low connectivity, the SDK has the potential to exhaust the user's upload bandwidth."));
        return true;
    }
    return false;
}
exports.warnIfCustomerDataLimitReached = warnIfCustomerDataLimitReached;
//# sourceMappingURL=heavyCustomerDataWarning.js.map